unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SNMPSynapse, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    SNMPSynapse1: TSNMPSynapse;
    HostEdit: TEdit;
    Label1: TLabel;
    CommunityEdit: TEdit;
    Label2: TLabel;
    SNMPGetGroupBox: TGroupBox;
    Label3: TLabel;
    SNMPGetOidEdit: TEdit;
    SNMPSetGroupBox: TGroupBox;
    Label4: TLabel;
    SNMPSetOidEdit: TEdit;
    SNMPSetValueEdit: TEdit;
    SNMPSetValueTypeComboBox: TComboBox;
    SNMPGetButton: TButton;
    SNMPSetButton: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    Label7: TLabel;
    SNMPGetTableGroupBox: TGroupBox;
    Label8: TLabel;
    SNMPGetTableOidEdit: TEdit;
    ListBox1: TListBox;
    Label9: TLabel;
    SNMPGetTableButton: TButton;
    StatusBar1: TStatusBar;
    InstancedCheckBox: TCheckBox;
    procedure SNMPGetButtonClick(Sender: TObject);
    procedure SNMPSetButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SNMPGetTableButtonClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure SNMPSynapse1Throttle(Sender: TObject);
    procedure SNMPSynapse1Timeout(Sender: TObject; Host: string;
      Retry: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SNMPGetButtonClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  SNMPGetButton.Enabled := false;
  SNMPSynapse1.Community := CommunityEdit.Text;
  SNMPSynapse1.Host := HostEdit.Text;
  ShowMessage(SNMPSynapse1.SNMPGet(SNMPGetOidEdit.Text));
  SNMPGetButton.Enabled := true;
end;

procedure TForm1.SNMPSetButtonClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  SNMPSetButton.Enabled := false;
  SNMPSynapse1.Community := CommunityEdit.Text;
  SNMPSynapse1.Host := HostEdit.Text;
  ShowMessage(SNMPSynapse1.SNMPSet(SNMPSetOidEdit.Text, SNMPSetValueEdit.Text, SNMPSynapse1.ConvertStringToValueType(SNMPSetValueTypeComboBox.Text)));
  SNMPSetButton.Enabled := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SNMPSetValueTypeComboBox.ItemIndex := 1;
end;

procedure TForm1.SNMPGetTableButtonClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  Screen.Cursor := crHourGlass;
  SNMPGetTableButton.Enabled := false;
  SNMPSynapse1.Community := CommunityEdit.Text;
  SNMPSynapse1.Host := HostEdit.Text;
  SNMPSynapse1.SNMPGetTable(SNMPGetTableOidEdit.Text, InstancedCheckBox.Checked);
  ListBox1.Clear;
  ListBox1.Items.Assign(SNMPSynapse1.ValueList);
  SNMPGetTableButton.Enabled := true;
  Screen.Cursor := crDefault;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  i: integer;

  function StrCharCount(const S: AnsiString; C: AnsiChar): Integer;
  var
    I: Integer;
  begin
    Result := 0;
    for I := 1 to Length(S) do
      if S[I] = C then
        Inc(Result);
  end;

begin
  if (ListBox1.ItemIndex > -1) and (ListBox1.ItemIndex < SNMPSynapse1.ValueList.Count) then
  begin
    for i := 0 to StrCharCount(SNMPSynapse1.ValueList[ListBox1.ItemIndex], ',') do
      ShowMessage(SNMPSynapse1.ExtractValueListData(ListBox1.ItemIndex, i));
  end;
end;

procedure TForm1.SNMPSynapse1Throttle(Sender: TObject);
begin
  StatusBar1.SimpleText := 'SNMP Throttle';
end;

procedure TForm1.SNMPSynapse1Timeout(Sender: TObject; Host: string;
  Retry: Integer);
begin
  StatusBar1.SimpleText := 'SNMP Timeout (' + Host + ')';
end;

end.

